"use strict";

var _events = require("events");

var _clightningClient = require("clightning-client");

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var debug = require('debug')('lightning-charge');

var PaymentListener = /*#__PURE__*/function (_EventEmitter) {
  _inherits(PaymentListener, _EventEmitter);

  var _super = _createSuper(PaymentListener);

  function PaymentListener(rpcPath, model) {
    var _this;

    _classCallCheck(this, PaymentListener);

    _this = _super.call(this);
    _this.ln = new _clightningClient.LightningClient(rpcPath);
    _this.model = model;

    _this.ln.client.on('connect', /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = _this;
                _context.next = 3;
                return model.getLastPaid();

              case 3:
                _context.t1 = _context.sent;
                return _context.abrupt("return", _context.t0.pollNext.call(_context.t0, _context.t1));

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    return _this;
  }

  _createClass(PaymentListener, [{
    key: "pollNext",
    value: function () {
      var _pollNext = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(last_index) {
        var _yield$this$ln$waitan, id, pay_index, paid_at, msatoshi_received, invoice;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.ln.waitanyinvoice(last_index);

              case 2:
                _yield$this$ln$waitan = _context2.sent;
                id = _yield$this$ln$waitan.label;
                pay_index = _yield$this$ln$waitan.pay_index;
                paid_at = _yield$this$ln$waitan.paid_at;
                msatoshi_received = _yield$this$ln$waitan.msatoshi_received;
                _context2.next = 9;
                return this.model.markPaid(id, pay_index, paid_at, msatoshi_received);

              case 9:
                if (!_context2.sent) {
                  _context2.next = 18;
                  break;
                }

                _context2.next = 12;
                return this.model.fetchInvoice(id);

              case 12:
                invoice = _context2.sent;
                debug('invoice %s paid: %o', invoice.id, invoice);
                this.emit('payment', invoice);
                this.emit('paid:' + id, invoice);
                _context2.next = 19;
                break;

              case 18:
                console.error('WARN: invoice %s from waitanyinvoice does not exists locally, or is already marked as paid', id);

              case 19:
                this.pollNext(pay_index);

              case 20:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function pollNext(_x2) {
        return _pollNext.apply(this, arguments);
      }

      return pollNext;
    }()
  }, {
    key: "register",
    value: function register(id, timeout) {
      var _this2 = this;

      debug('register(%s)', id);
      return new Promise(function (resolve, reject) {
        var onPay = function onPay(invoice) {
          clearTimeout(timer);

          _this2.removeListener("paid:".concat(id), onPay);

          resolve(invoice);
        };

        _this2.on("paid:".concat(id), onPay);

        var timer = setTimeout(function (_) {
          debug('invoice %s listener timed out', id);

          _this2.removeListener("paid:".concat(id), onPay);

          resolve(false);
        }, timeout);
      });
    }
  }]);

  return PaymentListener;
}(_events.EventEmitter); // optional new


module.exports = function () {
  for (var _len = arguments.length, a = new Array(_len), _key = 0; _key < _len; _key++) {
    a[_key] = arguments[_key];
  }

  return _construct(PaymentListener, a);
};